// Arduino G-code Interpreter
// v1.0 by Mike Ellery - initial software (mellery@gmail.com)
// v1.1 by Zach Hoeken - cleaned up and did lots of tweaks (hoeken@gmail.com)
// v1.2 by Chris Meighan - cleanup / G2&G3 support (cmeighan@gmail.com)
// v1.3 by Zach Hoeken - added thermocouple support and multi-sample temp readings. (hoeken@gmail.com)
#include <HardwareSerial.h>


//cartesian bot pins
//x axis pins
#define X_STEP_PIN      2
#define X_DIR_PIN       3
#define X_ENABLE_PIN    4
//#define X_MIN_PIN       5
//#define X_MAX_PIN       6


#define Y_STEP_PIN      8
#define Y_DIR_PIN       9
#define Y_ENABLE_PIN    10
//#define Y_MIN_PIN       11
//#define Y_MAX_PIN       12

#define Z_STEP_PIN      14
#define Z_DIR_PIN       15
#define Z_ENABLE_PIN    16
//#define Z_MIN_PIN       17
//#define Z_MAX_PIN       18

//our command string
#define COMMAND_SIZE 128
char word_[COMMAND_SIZE];
byte serial_count;
int no_data = 0;

void setup()
{
  //Do startup stuff here
  Serial.begin(19200);
  Serial.println("start");

  //other initialization.
  init_process_string();
  init_steppers();

 //increase clock resolution
  TCCR0B &= ~_BV(CS00); //for ATmega168!! XXX: this will mess up millis,micros,delay,delayMicroseconds
 

  //digitalWrite(X_MIN_PIN, HIGH);
  //digitalWrite(X_MAX_PIN, HIGH);
  //digitalWrite(Y_MIN_PIN, HIGH);
  //digitalWrite(Y_MAX_PIN, HIGH);
  //digitalWrite(Z_MIN_PIN, HIGH);
 // digitalWrite(Z_MAX_PIN, HIGH);

  digitalWrite(X_ENABLE_PIN, LOW); //enable

  digitalWrite(X_DIR_PIN, HIGH);
  for (int i=0; i<400; i++)
  {
    do_step(X_STEP_PIN);
  }
  digitalWrite(X_DIR_PIN, LOW);
 for (int i=0; i<400; i++)
  {
    do_step(X_STEP_PIN);
  }

}

void loop()
{
  char c;

  //keep it hot!


  //read in characters if we got them.
  if (Serial.available() > 0)
  {
    c = Serial.read();
    no_data = 0;

    //newlines are ends of commands.
    if (c != '\n')
    {
      word_[serial_count] = c;
      serial_count++;
    }
  }
  //mark no data.
  else
  {
    no_data++;
    delayMicroseconds(100);
  }

  //if theres a pause or we got a real command, do it
  if (serial_count && (c == '\n' || no_data > 100))
  {
    //process our command!
    process_string(word_, serial_count);

    //clear command.
    init_process_string();
  }

  //no data?  turn off steppers
//  if (no_data > 1000)
//    disable_steppers();
}

/*
G21
G0 
X0.0 
Y0.0
G01
Y0.5 
X0.5 
Y0.0 
X0.0
G03I-1.0

http://reprap.org/wiki/Arduino_GCode_Interpreter
*/

